package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Utilities.SceneLoader;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Exceptions.DatabaseException;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Exceptions.ParserException;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Persistence;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.Utilities.Parser;
import javafx.application.Platform;
import javafx.fxml.FXML;
import javafx.fxml.Initializable;
import javafx.scene.control.Label;
import javafx.scene.control.TextField;
import javafx.scene.layout.VBox;

import java.net.URL;
import java.security.NoSuchAlgorithmException;
import java.util.ResourceBundle;

public class LoginController {
    @FXML
    private VBox parent;
    @FXML
    private TextField playerName, password;
    @FXML
    private Label errorMessage;

    SceneLoader sceneLoader = new SceneLoader();
    Persistence persistence = Persistence.getInstance();

    private void switchScene(String name) {
        parent.getChildren().clear();
        parent.getChildren().add(sceneLoader.loadScene(name));
    }

    @FXML
    private void login() {
        errorMessage.setMaxWidth(parent.getWidth());
        errorMessage.setText("Loading an eternity because of slow SQL server...");
        thread.start();
    }

    Thread thread = new Thread(() -> {
        try {
            persistence.login(playerName.getText(), password.getText());
            persistence.loadPlayerStatistics();
            Platform.runLater(() -> switchScene("MainMenu"));
        } catch (NoSuchAlgorithmException e) {
            throw new RuntimeException(e);
        } catch (DatabaseException e) {
            Platform.runLater(() -> errorMessage.setText(e.getMessage()));
        }
    });

    @FXML
    private void back() {
        thread.interrupt();
        switchScene("PlayerCreateScene");
    }
}
