package de.hdm_stuttgart.battlearena.Controller;

import de.hdm_stuttgart.battlearena.Controller.Enum.GameState;
import de.hdm_stuttgart.battlearena.Controller.Utilities.CreateMediaPlayer;
import de.hdm_stuttgart.battlearena.Model.DataStorage.Classes.RuntimeInfo;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.control.Button;
import javafx.scene.layout.BorderPane;
import javafx.scene.media.Media;
import javafx.scene.media.MediaPlayer;
import javafx.scene.media.MediaView;

import java.io.File;
import java.io.IOException;
import java.net.URL;
import java.util.Objects;
import java.util.ResourceBundle;

public class PlaceholderController implements Initializable {
    @FXML
    private BorderPane parent;
    @FXML
    private MediaView mediaView;
    @FXML
    private Button button;
    private MediaPlayer mediaPlayer, musicPlayer;

    @Override
    public void initialize(URL url, ResourceBundle resourceBundle) {
        File file = new File("src/main/resources/videos/construction.mp4");
        mediaPlayer = new CreateMediaPlayer().getMediaPlayer(mediaView, file, true, parent);
        mediaView.setMediaPlayer(mediaPlayer);
        mediaPlayer.setCycleCount(MediaPlayer.INDEFINITE);
        parent.setStyle("-fx-font-size: 50; -fx-text-fill: white; -fx-font-family: 'Arial Black'");

        button.setOnMouseClicked(mouseEvent -> {
            try {
                mediaPlayer.dispose();
                RuntimeInfo.getInstance().setGameState(GameState.MENU);
                parent.getScene().setRoot(FXMLLoader.load(Objects.requireNonNull(getClass().getResource("/fxml/MenuBorderPane.fxml"))));
            } catch (IOException e) {
                throw new RuntimeException();
            }
        });
    }
}
