package de.hdm_stuttgart.battlearena.Model.Multiplayer;

import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.net.*;
import java.io.*;
import java.util.Arrays;

public class Client {
    private Socket clientSocket;
    private PrintWriter out;
    private BufferedReader in;

    private static final Logger log = LogManager.getLogger(Client.class);

    public void startConnection(String ip, int port) throws IOException {
        clientSocket = new Socket(ip, port);
        out = new PrintWriter(clientSocket.getOutputStream(), true);
        in = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
    }

    public int[] sendcords(int[] cords) throws IOException {
        String message = String.join(",", Arrays.stream(cords).mapToObj(String::valueOf).toArray(String[]::new));
        out.println(message);
      //  log.info("Sent coordinates: " + message);
        String resp = in.readLine();
        return convertStringToArray(resp);
    }

    public static int[] convertStringToArray(String inputString) {
        // Remove brackets and split by comma
        String[] parts = inputString.substring(1, inputString.length() - 1).split(",");

        // Convert each part to integer
        int[] result = new int[parts.length];
        for (int i = 0; i < parts.length; i++) {
            result[i] = Integer.parseInt(parts[i].trim());
        }

        return result;
    }

    public void stopConnection() throws IOException {
        in.close();
        out.close();
        clientSocket.close();
    }
}
